Page MenuHomePhabricator

GSOC 2022 Project Proposal "Edit Request Wizard"
Closed, DeclinedPublic

Assigned To
Authored By
AmeyGupta
Apr 5 2022, 1:01 PM
Referenced Files
F35054171: Screenshot (395).png
Apr 16 2022, 1:10 PM
F35054176: Screenshot (396).png
Apr 16 2022, 1:10 PM
F35043784: Screenshot (394).png
Apr 8 2022, 1:44 PM
F35043781: Screenshot (391).png
Apr 8 2022, 1:44 PM
F35043782: Screenshot (392).png
Apr 8 2022, 1:44 PM
F35043783: Screenshot (393).png
Apr 8 2022, 1:44 PM

Description

Profile Information

Name: Amey Gupta
IRC nickname on libera.chat IRC : Amey1619
Email ID: somu160202@gmail.com
Zulip: AMEY Gupta
GitHub: https://github.com/Amey1619
Location: New Delhi, India
Timezone: IST (UTC + 5:30)
Typical working hours : Working hours : - UTC 10:30 AM to UTC 5:30 PM [IST 4:00 PM to IST 11:00 PM].

Synopsis

Wikipedia is an online open-source encyclopedia that offers a vast sea of knowledge but behind its success the main reason is the Wikipedians who give there best effort to edit these article and provide us with these informative articles. The goal of this project is to help these Wikipedians by creating a simpler and more efficient version of making an "Edit Request" so that anyone from all over the world can submit an edit request for any article easily. This project will aim at redesigning process of making an edit request so that any interested individual can create good edits without worrying about the set of rules and regulations. The main focus of this project will be at providing high quality guidance , error handling and a more user friendly interface for beginners for making a edit request . At the end this project will help the Wikipedia to attract more and more good editors in submitting their edit request. Thus, satisfying the goal of Wikipedia that "Everyone can edit" .

Possible Mentors: @Enterprisey, @Firefly, @SD0001

Have you contacted your mentors already? Yes, I have contacted the Mentors.

Timeline

PeriodTask
May 20 to June 12Community bonding period: Focus will be on designing a mock-up UI and learning the basics of the project (like user script and mediawiki API) and discussing the project with mentors and familiarizing with the community.
June 13 to June 20Summarizing the rules of making an edit request and Redesigning the page that stores information about edits .
June 20 to June 27Developing a feature that inform the user about their edit request
June 28 to July 8Working on a feature that helps in identifying errors and rectifying it and try to simplify the process.
July 9 to July 16Developing and testing the form to take input for the source.
July 17 to July 28Fixing up patches and bugs and testing the codebase for the same.
July 29Phase 1 Evaluation.
July 30 to August 6Doing research on source (URL,ISBN) validation for better implementation.
August 7 to August 13Adding source validation part and developing backend for the same.
August 14 to August 21Working on implementing quotations and its validation (i.e. coming from source).
August 22 to September 1Adding final submit buttons and testing up the entire project .
September 2 to September 4Preparing up final report, Fixing-up bugs and cleaning up code for submission.
September 5 to September 12Final week Submitting the final code for mentors reviewing
September 13 to September 19Evaluation by the mentors
September 20Initial GSOC 2022 Results Announced
  • A few days have been left around final evaluation periods for final touch-ups and preparations for evaluation submissions.

Deliverables

  • Summarizing the rules and policies of making edit request
  • A feature that automatically inform the maintainer about the specific edit request and also the editor of that page
  • Redesigning the page that stores information about the edits made on any article
  • Developing pop-up for displaying error while making edit request
  • Guiding user in rectifying those errors
  • Developing a 'hint' icon button on every step to avoid confusion
  • Implementing a form to input source

Phase 1 Evaluation

  • Developing an input form for source
  • Working on invalid source handling
  • Implementing a form to input quote
  • Checking if quote comes from valid source
  • Documentation and fixing bugs

Final Evaluation

Participation

  • I will be making a git repo with- main and master branches and will be committing code to the master branch daily after it is reviewed by mentors .
  • I will be creating pull requests when a feature would be ready to be tested and deployed .
  • Reachable anytime easily through email\Zulip. A well planned session if required: - UTC 9:30 AM to UTC 5:30 PM [IST 3:00 PM to IST 11:00 PM].
  • Feedback and code reviews can be done through Phabricator by commenting on the appropriate subtask
  • I will be writing weekly reports on the progress on the meta wiki. User page
  • I also plan on writing a small blog about every task after its completion on my blog. Profile

About Me

I am a 20-year-old, junior enrolled in Information Technology at Indian Institute of Information Technology (IIIT) Sonipat. I developed a passion for development in my freshmen year and from then, most of my time goes into reading and writing software. I came to know about GSOC at the end of my freshmen year and also the importance of open source contribution in Tech world.

My End-semester exams will be from May 18 to May 30 and during this time I will be less active for community bonding , but I am sure that I will still be able to give at least 30 hours a week to this project .I am not planning any vacations during the GSOC period. My summer vacations begin on the 31th of May and end on the 2nd of August during which I’ll be completely free to work on the project. The coding period of GSOC will be from 13th of June to the 4th of September during which I can easily devote 40 hours per week and 30 hours per week after my college reopens. I plan to complete most of my work before my college reopens .

Why am I interested in "Edit Request Wizard" project of Wikimedia ?

The "Edit Request wizard" is a crucial way of maintaining and improving the quality of Wikipedia articles as anyone from anywhere can edit these article. Which make it a true open-source project . This project will make editing more accessible for people from all backgrounds thus helping Wikipedia to achieve it goal to make easy for anyone to become a editor. Moreover, I have experience in working with Front-end (HTML/CSS/JS) , ReactJS , PHP and Python. Due to which I believe I’ll be a very good fit for accomplishing the primary goals for the projects statements.

*This is my First time contribution to open source and I am applying for GSOC so I am hoping to make a positive impact through it for beginners at Wikipedia by helping them in making their first edit request.

Past Experience

  • I worked on ‘Algorithm Visualizer' which is a free of cost website that provides you a platform to learn pathfinding algorithm with help of visual animations and provides you with an innovative and interesting way to learn Coding. It was a (HTML/CSS/JS) project developed by me and my teammates and I worked on the front-end and maze building function of the project. This project taught me how to work in team and how to meet up to deadline.
  • You can also check my project here. Project
  • Also created a todos-list using a reactJS In which I applied text validation. Project
  • I have a created a travel form in which a student can apply for school trip It stores there data with the help of PHP and Xampp server. Project
  • Also created a python bot can take verbal command and process them and sends email using those commands. Project

Microtasks

Microtask1
In this microtask I have explained about Procedure of making an edit request ,the hardest part of making edit in Wikipedia and some changes in "Edit Request" and how we can achieve them.

Microtask2
I have designed a mockup UI of the source submission form. The design is made on figma, I have tried to keep the design similar to the original design of the Wikipedia Page. I have also described about source validation part above. Input_source_design

Microtask3
This a simple text area design for submitting Quotation. It is based on HTML, CSS and JS and it uses simple JavaScript validation for checking if Quote is valid or not .

Screenshot (392).png (428×1 px, 22 KB)

Screenshot (393).png (371×1 px, 19 KB)

Screenshot (394).png (378×1 px, 22 KB)

You can notice that the form does not allow any whitespaces, empty spaces and the entered text must only be alphanumeric.

Screenshot (391).png (459×745 px, 33 KB)

Above , is the given code which I used for validation. For checking that the quote comes from a valid source . We first have to work on source Validation and link the Quotation form after it. The user can submit Quote only after he cited an valid source.

Microtask4

For This task I developed a simple code using python which check the validation of URL in 4 stages that is

  • It check if URL is submitted is not an empty string.
  • It check if URL follow the https://www.example.com/ or http://www.example.com or any other format, through the help of regex expression
  • It also avoid google search results and any results from Facebook also.
  • I also developed a function which automatically avoid invalid URL by using requests method of python. It will send a get request for the entered URL and check if status code (function of python) returns the value [200] for entered website so it will be a valid website. For example:

Screenshot (395).png (323×1 px, 64 KB)

Note that after I changed the URL form https://github.com/Amey1619 to https://github.com/Amey2002/ it is showing an Invalid URL as output. After some modification to this code, it can integrate to source citation and be used for URL validation. It can also be integrated with front-end and show some alert message to the user about the source being valid or not.

Screenshot (396).png (338×1 px, 64 KB)

Post Gsoc Involvement

I would like to continue being an active member of the organization. There will still be a lot of prospective work that’ll be necessary to be accomplished. Some of the issues are mentioned here,

  • an interface to show these edit requests to experienced editors as they read the article
  • an interface for the general public to express feedback on these edit requests (as a "safety valve") moderation interfaces
  • interfaces to supervise the process (for example, to see URLs that have recently been disallowed by an automated process)

    I would like to stay in touch with the community and help out wherever I can, post GSoC .

Related Objects

StatusSubtypeAssignedTask
OpenNone
DeclinedAmeyGupta

Event Timeline

AmeyGupta updated the task description. (Show Details)
AmeyGupta added a project: Outreachy.
AmeyGupta edited projects, added Outreachy (Round 24); removed Outreachy.
AmeyGupta updated the task description. (Show Details)
AmeyGupta updated the task description. (Show Details)
AmeyGupta added a subscriber: Enterprisey.

Hi! I am Srishti, one of the org admins - it's great to see your interest in applying to GSoC with Wikimedia! You can safely ignore this message if you have already followed our participants' guide. As you develop your proposal, we want to ensure that you follow the application process steps: https://www.mediawiki.org/wiki/Google_Summer_of_Code/Participants#Application_process_steps, primarily communicate with project mentors, integrate their feedback in your proposal, adhere to the guidelines around proposal submission, contribute to microtasks, etc. Let us know if there are any questions!

And, if you are applying to Outreachy too, remember to follow the guidelines here https://www.mediawiki.org/wiki/Outreachy/Participants.

As the GSoC deadline is soon approaching in less than 24 hours (April 19, 2022, 18:00 UTC), please ensure that the information in your proposal on Phabricator is complete and you have already submitted it on the Google's program website in the recommended format. When you have done so, please move your proposal here on the Phabricator workboard https://phabricator.wikimedia.org/project/board/5716/ from "Proposals in Progress" to the "Proposals Submitted' column by simply dragging it. Let us know if you have any questions.

Gopavasanth added a subscriber: Gopavasanth.

@AmeyGupta We are sorry to say that we could not allocate a slot for you this time. Please do not consider the rejection to be an assessment of your proposal. We received over 75 quality applications, and we could only accept 10 students. We were not able to give all applicants a slot that would have deserved one, and these were some very tough decisions to make. Please know that you are still a valued member of our community and we by no means want to exclude you. Many students who we did not accept in 2021 have become Wikimedia maintainers, contractors and even GSoC students and mentors this year!

Your ideas and contributions to our projects are still welcome! As a next step, you could consider finishing up any pending pull requests or inform us that someone has to take them over. Here is the recommended place for you to get started as a newcomer: https://www.mediawiki.org/wiki/New_Developers.

If you would still be eligible for GSoC next year, we look forward to your participation